! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: gfortran 
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema: Dado uma lista de números, encontrar
! o maior, o menor e suas respectivas posicoes


PROGRAM exercicio7v2; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        INTEGER :: numeracao; ! recebe primeira coluna do arquivo texto
        REAL :: valor; ! recebe segunda coluna do arquivo texto
        INTEGER :: estado; ! verifica se não tem erro de entrada
        INTEGER :: counter; ! Conta quantas linhas o arquivo de entrada possui
        REAL :: menor; ! Armazena o menor valor
        REAL :: maior; ! Armazena o maior valor
        INTEGER :: posicaomaior; ! Armazena a posicao do maior valor
        INTEGER :: posicaomenor; ! Armazenaa a posicao do menor valor
        CHARACTER(Len=*), PARAMETER :: error1 = 'Problema na leitura do arquivo&
        & de entrada'; ! Mensagem de erro caso o arquivo de entrada não esteja OK
        ! Define arquivo de entrada
        CHARACTER(Len=*), PARAMETER :: input_file = './input_exercicio7.txt'; 
        ! Define arquivo de saída
        CHARACTER(Len=*), PARAMETER :: output_file = './output_exercicio7.txt';
        
        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 30/10/09'; 
        PRINT *, 'Programa exercicio7v2.'; PRINT *, '';

        ! Receber e armazenar dados
        CALL escrita; ! Abre o arquivo de saída para escrita
         
        WRITE(UNIT=101, FMT=*) 'POSICAO ', 'VALOR';
        
        ! Valores iniciais para counter, menor e maior'
        counter = 0;
        maior = 0;
        menor = 1;
        DO 
                CALL leitura; ! Abre o arquivo para leitura
                ! Le o arquivo, caso encontre o EOF, vai para o label 88
                READ(UNIT=100, FMT=*, IOSTAT=estado, END=88) numeracao, valor;
                IF (estado /= 0) STOP error1; ! Checagem da leitura ok do arquivo
                counter = counter+1; !Contando o número de elementos 
                WRITE(UNIT=101, FMT=*) counter, valor;
                IF (valor > maior) THEN 
                        maior = valor;
                        posicaomaior = counter;
                END IF
                IF (valor < menor) THEN
                        menor = valor;
                        posicaomenor = counter;
                END IF
        END DO;
        
        ! Imprimir dados recebidos e resultados
88      WRITE(UNIT=101, FMT=*) '% O maior valor é ', maior, 'na posicao ',&
        &posicaomaior;
        WRITE(UNIT=101, FMT=*) '% O menor valor é ', menor, 'na posicao ',&
        &posicaomenor;
        WRITE(UNIT=101, FMT=*) '% Total de numeros lidos', counter;

        PRINT *, 'Resultados impressos em ', output_file;


        !Funções
        CONTAINS
        SUBROUTINE leitura; ! Abrir arquivo para leitura 
                OPEN(UNIT=100, FILE=input_file, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='READ');
        END SUBROUTINE leitura; ! Fim abrir arquivo para leitura

        SUBROUTINE escrita; ! Abrir arquivo para escrita
                OPEN(UNIT=101, FILE=output_file, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='WRITE');
        END SUBROUTINE escrita; ! Fim abrir arquivo para escrita
       
END PROGRAM exercicio7v2; ! Fim do programa
