! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcular a média harmonica para N entradas
! sem saber a priori quantas entradas serão

PROGRAM harmonica3; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        CHARACTER(Len=*), PARAMETER :: error1 = 'Erro1: Não foi recebida nenhuma&
        & entrada válida. Programa terminado.';
        REAL(Kind=16) :: entrada; ! Recebe os dados de entrada
        INTEGER :: counter; ! Conta quantos números foram entrados
        REAL(Kind=16) :: somatorio = 0; ! Soma os inversos das entradas
        
        !Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 31/08/09'; 
        PRINT *, 'Programa harmonica3.'; PRINT *, '';

        !Receber, armazenar dados e echoar na tela
        PRINT*, 'Entre com os valores para calcular a média harmonica, os dados& 
                & devem ser separados por <ENTER>, para terminar digite 0 ou al&
                &gum número negativo.';
        
        counter = 0;
        DO
                READ*, entrada;
                IF (entrada <=0 .AND. counter==0) STOP error1; ! Check error1
                IF (entrada <= 0) EXIT; ! Sai do laço caso receba entrada<=0.
                counter = counter + 1; ! Incrementa o contador
                PRINT*, 'Entrada ', counter, 'recebida é ',entrada;
                somatorio = somatorio + 1.0/entrada; ! adciona o inverso da entrada ao somatorio
                PRINT*, 'Somatorio parcial dos inversos: ',somatorio;
        END DO;
                 
        !Processamento e Impressão do resultado
        PRINT*, 'Media harmonica é ', counter/somatorio;
        
END PROGRAM harmonica3; ! Fim do programa
