! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula o produto matricial, matrizxvetor

PROGRAM mproduct; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        CHARACTER(Len=*), PARAMETER :: input1 = './matrix2.txt'
        CHARACTER(Len=*), PARAMETER :: output1 = './output_mproduct.txt'
        INTEGER :: unidade1 = 100;
        INTEGER :: unidade2 = 101;
        INTEGER :: unidade3 = 101;
        REAL, DIMENSION(:,:), ALLOCATABLE :: matrixA;
        REAL, DIMENSION(:), ALLOCATABLE :: matrixB;
        REAL, DIMENSION(:), ALLOCATABLE :: matrixC;
        INTEGER :: estado;
        INTEGER :: linhas;
        REAL :: tmp;
        INTEGER :: i,j;


        !Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 8/11/09'; 
        PRINT *, 'Programa mproduct.'; PRINT *, '';

        CALL leitura(input1, unidade1);
        linhas = 0;
        estado = 0;
        DO
                IF (estado == -1) EXIT;
                IF (estado /= -1 .AND. estado /= 0) STOP 'erro de leitura';
                linhas = linhas + 1;
                READ(UNIT=unidade1, FMT=*, IOSTAT=estado) tmp;
                PRINT*, estado;
        END DO;
        
        linhas = linhas - 1; 
        ALLOCATE(matrixA(linhas,linhas));
        ALLOCATE(matrixB(linhas));
        CALL leitura(input1,unidade2);
        DO i = 1, linhas, 1;
                READ(UNIT=unidade2, FMT=*, IOSTAT=estado) (matrixA(i,j), j=1, linhas), matrixB(i);
        END DO;
        
        
        DO i = 1, linhas, 1;
                PRINT*, (matrixA(i,j), j=1, linhas);
        END DO;
      
         
        DO i = 1, linhas, 1;
                PRINT*, matrixB(i);
        END DO;
        
        ALLOCATE(matrixC(linhas));
        CALL matrixproduct(matrixA,matrixB,linhas,matrixC); 
        
        DO i = 1, linhas, 1;
               PRINT*, matrixC(i);
        END DO;
        
END PROGRAM mproduct; ! Fim do programa
