! MEU BANCO DE ROTINAS
! Última alteração 4/11/09

SUBROUTINE crossprod(a,cross) ! Começo funcao cross
        IMPLICIT NONE;
        REAL, DIMENSION(2,3), INTENT(IN) :: a;
        REAL, DIMENSION(3), INTENT(OUT) :: cross;
        cross(1) = a(1,2)*a(2,3)-a(2,2)*a(1,3); ! Calcula i
        cross(2) = -1*(a(1,1)*a(2,3)-a(2,1)*a(1,3)); ! Calcula j
        cross(3) = a(1,1)*a(2,2)-a(2,1)*a(1,2)! Calcula k
END SUBROUTINE crossprod; ! fim funcao cross

SUBROUTINE leitura(a); ! Abrir arquivo para leitura
        IMPLICIT NONE;
        CHARACTER(Len=*), INTENT(IN) :: a;
        INTEGER :: teste;
        OPEN(UNIT=100, FILE=a, STATUS='OLD', ACCESS='SEQUENTIAL', &
        & ACTION='READ', IOSTAT=teste);
        IF (teste /= 0) STOP 'Erro de leitura do arquivo de entrada.&
        & Gere um arquivo válido';
        END SUBROUTINE leitura; ! Fim abrir arquivo para leitura

SUBROUTINE escrita(a); ! Abrir arquivo para escrita
        IMPLICIT NONE;
        CHARACTER(Len=*), INTENT(IN) :: a;
        OPEN(UNIT=101, FILE=a, STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
        & ACTION='WRITE');
END SUBROUTINE escrita; ! Fim abrir arquivo para escrita
