! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: gfortran 
! Sistema Operacional: Mandriva 2009.0

! Problema: Calcula fatorial de n, calcula
! número de euler, dando o erro percentual


PROGRAM exercicio6; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL(Kind=8), PARAMETER :: e = 2.7182818284590452353602875d0; ! Constante de euler
        CHARACTER(Len=*), PARAMETER :: error1 = 'Entrada inválida, programa terminado'; ! Erro para opcao invalida
        CHARACTER(Len=*), PARAMETER :: error2 = 'Entrada inválida, o número não&
        & é inteiro ou é negativo'; ! Erro para entrada invalida dentro do case
        INTEGER :: opcao; ! Recebe opcao escolhida do menu
        INTEGER :: entrada1; ! Entrada dentro do case
        INTEGER :: estado; ! Armazena estado do iostat

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 23/08/09'; 
        PRINT *, 'Programa escape2.'; PRINT *, '';

        ! Receber e armazenar dados
        PRINT*, 'O que você deseja fazer:';
        PRINT*, '- Digite 1, para calcular fatorial de um número.';
        PRINT*, '- Digite 2, para calcular número de euler para n passos.';
        READ(*,*), opcao;

        !Seleciona a opção
        SELECT CASE(opcao)
                CASE(1) ! Entra aqui para calcular o fatorial
                        PRINT*,'Entre o número inteiro desejado para calcular o número &
                        &fatorial: ';
                        READ(*,*,IOSTAT=estado) entrada1;
                        IF(estado/=0 .OR. entrada1 < 0) STOP error2; ! Checagem da entrada
                        CALL abrir; ! Abre o arquivo para saida dos dados
                        WRITE(100,*) entrada1, '! = ', fatorial(entrada1);
                CASE(2) ! Entrada para calcular euler com n passos
                        PRINT*,'Entre o número inteiro de passos desejados para o &
                        &cálculo do número de euler: ';
                        READ(*,*,IOSTAT=estado) entrada1;
                        IF(estado/=0 .OR. entrada1 <= 0) STOP error2; ! Checagem da entrada
                        CALL abrir; ! Abre o arquivo para saida dos dados
                        WRITE(100,*) 'Numero de euler com', entrada1, 'passos ', euler(entrada1);
                        WRITE(100,*) 'Comparando com e =', e, 'o erro encontrado foi: ', ((e-euler(entrada1))/e)*100, '%';
                CASE DEFAULT
                        STOP error1; ! Caso a selecao seja inválida
        END SELECT
            
        ! Funções
        CONTAINS
        INTEGER FUNCTION fatorial(a) ! Começo funcao fatorial
                INTEGER, INTENT(IN) :: a;
                INTEGER :: counter;
                fatorial = 1;
                DO counter = 1, a, 1
                        fatorial = fatorial*counter;
                END DO
        END FUNCTION fatorial; ! fim funcao fatorial

        REAL FUNCTION euler(a) ! comeco funcao euler
                INTEGER, INTENT(IN) :: a; ! numero de termos para calcular euler
                INTEGER :: counter;
                euler = 0;
                DO counter = 0, a-1, 1
                        euler = euler+(1.0/fatorial(counter));
                END DO
        END FUNCTION euler; ! fim funcao euler
        
        SUBROUTINE abrir; ! Abrir arquivo para escrita
                OPEN(UNIT=100, FILE='./output_exercicio6.txt', STATUS='UNKNOWN', ACCESS='SEQUENTIAL', &
                & ACTION='WRITE');
        END SUBROUTINE abrir; ! Fim abrir arquivo para escrita

END PROGRAM exercicio6; ! Fim do programa
