! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula média harmonica e geometrica
! para uma entrada de n números.

PROGRAM harm_geo1; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL :: mgeom; ! Media geometrica
        REAL :: mharm; ! Media harmonica
        REAL :: entrada; ! Recebe a entrada de dados
        REAL :: soma_inv; ! Soma dos inversos harmonica
        REAL :: produto; ! Produto das entradas
        INTEGER :: counter ! Contador do laço
        CHARACTER(Len=*), PARAMETER :: error1 = 'Erro1: Não foi recebida nenhuma&
        & entrada válida. Programa terminado.';
        
        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 6/10/2009'; 
        PRINT *, 'Programa harm_geo1.'; PRINT *, '';
        
        ! Imprime cabeçalho e instruções
        PRINT *, 'Esse programa calcula a média harmonica para n dados números';
        PRINT *, 'Entre o número e aperte <enter>. Caso o número 0 seja entrado,&
                & automaticamente ambas as médias serão retornada 0 e o programa&
                & será encerrado. Para terminar, entre qualquer número negativo.';
        
        ! Entrada de dados e processamento.
        counter = 0;
        produto = 1.0;
        soma_inv = 0;
        DO 
                READ *, entrada;
                IF ((entrada < 0) .AND. counter==0) THEN
                        ! Entrada aqui caso entrada seja negativa
                        ! e não tenha nenhuma entrada válida anterior
                        STOP error1;
                ELSE IF (entrada == 0) THEN
                        ! Entra aqui, caso a entrada seja 0.
                        mharm = 0; 
                        mgeom = 0;
                        PRINT *, 'Media geométrica: ', mgeom;
                        PRINT *, 'Média harmônica: ', mharm;
                        EXIT;
                ELSE IF (entrada < 0) THEN
                        ! Recebendo entrada < 0 && counter >= 1, sai do laço.
                        EXIT;
                END IF        
                
                ! Incrementa contador.
                counter = counter+1;
                PRINT *, 'Entrada número: ', counter; 
                PRINT *, 'Entrada lida: ', entrada; 
                ! Acumula produto das entradas
                produto = produto*entrada;
                PRINT *, 'Produto parcial: ', produto;
                ! Acumula soma dos inversos das entradas
                soma_inv = soma_inv+1.0/entrada;
                PRINT *, 'Soma dos inversos: ', soma_inv;
        END DO

       ! Processamento e impressão das saídas
       ! Calcula as médias geométrica e harmônica
       mgeom = produto**(1.0/counter);
       mharm = counter*1.0/soma_inv;
       PRINT *, 'Media geométrica: ', mgeom;
       PRINT *, 'Média harmônica: ', mharm;
   
END PROGRAM harm_geo1; ! Fim do programa
