! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Calcula o produto matricial, matrizxvetor

PROGRAM mproduct; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        CHARACTER(Len=*), PARAMETER :: input1 = './squarematrix.txt'
        CHARACTER(Len=*), PARAMETER :: input2 = './vector.txt'
        CHARACTER(Len=*), PARAMETER :: output1 = './output_mproduct.txt'
        INTEGER :: unidade1 = 100;
        INTEGER :: unidade2 = 101;
        INTEGER :: unidade3 = 102;
        REAL, DIMENSION(:,:), ALLOCATABLE :: squarematrix;
        REAL, DIMENSION(:), ALLOCATABLE :: vector;
        REAL, DIMENSION(:), ALLOCATABLE :: vresult;
        INTEGER :: estado;
        INTEGER :: linhas;
        REAL :: tmp;
        INTEGER :: i,j;


        !Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 8/11/09'; 
        PRINT *, 'Programa mproduct.'; PRINT *, '';

        CALL leitura(input2, unidade2);
        linhas = 0;
        estado = 0;
        DO
                IF (estado == -1) EXIT;
                IF (estado /= -1 .AND. estado /= 0) STOP 'erro de leitura';
                linhas = linhas + 1;
                READ(UNIT=unidade2, FMT=*, IOSTAT=estado) tmp;
                PRINT*, estado;
        END DO;
        
        linhas = linhas - 1; 
        ALLOCATE(vector(linhas));
        ALLOCATE(squarematrix(linhas,linhas));
        CALL leitura(input2,unidade3);
        CALL leitura(input1,unidade1);
        DO i = 1, linhas, 1;
                READ(UNIT=unidade3, FMT=*, IOSTAT=estado) vector(i);
                
                DO j = 1, linhas, 1;
                        READ(UNIT=unidade1, FMT=*, IOSTAT=estado) squarematrix(i,j);
                END DO
        END DO;
        
        
        DO i = 1, linhas, 1;
                DO j = 1, linhas, 1;
                        PRINT*, i, j, squarematrix(i,j);
                END DO;
        END DO;
        
        
        DO i = 1, linhas, 1;
                PRINT*, vector(i);
        END DO;

        ALLOCATE(vresult(linhas));
        CALL matrixproduct(squarematrix,vector,linhas,vresult); 
        
        DO i = 1, linhas, 1;
                PRINT*, vresult(i);
        END DO;
        
END PROGRAM mproduct; ! Fim do programa
