! Leonardo Marques, 06/89041
! Programacao para Sistemas Fisicos - Turma A

! Ambiente de desenvolvimento:
! Compilador: ifort 11.0
! Sistema Operacional: Ubuntu GNU/Linux 8.10

! Problema:
! Dados os coeficientes a, b e c de uma equação
! quadrática, ax^2+bx+c, retornar as possíveis
! soluções. 

PROGRAM quadratica; ! Começo do Programa

        ! Variaveis
        IMPLICIT NONE;
        REAL :: a, b, c; ! Coeficientes de ax^2+bx+c
        REAL :: delta; ! delta ou discriminante
        REAL :: r1, r2; ! raízes da equação
        CHARACTER(Len=*), PARAMETER :: error1 = 'error1: a=0, não é uma equação de segundo grau!'; ! teste a/=0

        ! Dados do programador 
        PRINT *, 'Leonardo Marques, 06/89041';
        PRINT *, 'Engenharia Elétrica, 5º semestre';
        PRINT *, 'Data de hoje 24/08/09';
        PRINT *, 'Programa quadratica.'; PRINT *, '';

        ! Receber e armazenar dados
        PRINT*, 'Entre com os coeficientes no formato: a b c';
        READ*, a, b ,c;

        ! Processamento
        IF (a == 0) STOP error1; ! Checa se de fato é uma eq quadratica
        
        delta = b**2-4*a*c; ! Calcula delta, caso o a/=0
        
        ! nessa cadeia lógica, há o cálculo das raízes e impressão dos resultados
        ! entra aqui caso delta > 0
        IF (delta > 0) THEN
                r1 = (-b+SQRT(delta))/2.0*a;
                r2 = (-b-SQRT(delta))/2.0*a; 
                PRINT*, 'As raízes são r1=', r1, ' e r2=', r2;
                ! entra aqui caso delta == 0
                ELSE IF (delta == 0) THEN
                        r1 = (-b)/2.0*a;
                        PRINT*, 'As raízes são r1=r2=',r1;
                ! entra aqui caso delta < 0
                ELSE 
                        PRINT*, 'As raízes são r1=', (-b/2.0*a),'+',SQRT(-delta)/2.0*a,'i', &
                        &' e r2=', (-b/2.0*a),'-',SQRT(-delta)/2.0*a,'i';
        END IF          
        
END PROGRAM quadratica; ! Fim do programa
